@echo off
:askpath
if exist dppath.txt goto menu
echo Welcome to DPGet! Please enter your DPBall directory. (Enter for default)
set dpdirectory=
set /p dpdirectory=
echo Please enter it once more to verify...
set dpdirectorycheck=
set /p dpdirectorycheck=
if '%dpdirectory%'=='%dpdirectorycheck%' goto pathadd
echo Entries do not match. Please re-enter.
pause
goto verify

:pathadd
if '%dpdirectory%'=='' goto defaultpathadd
echo %dpdirectory%>>dppath.txt
goto menu

:defaultpathadd
echo C:\games\paintball2>dppath.txt
goto menu

:menu
cls
if exist dpupdate.bat goto delupdate
set /p dppath= <dppath.txt
echo Welcome to the DPGet Digital Paintball File Downloader!
echo What would you like to do?
echo 1. Download a map
echo 2. Browse File Database
echo 3. Search file Database
echo 4. News
echo 5. Check for DPGet updates
echo 6. About
echo 7. Quit
set choice=
set /p choice=Enter your choice: 
if '%choice%'=='1' goto mapmenu
if '%choice%'=='2' goto browsefiles
if '%choice%'=='3' goto searchfiles
if '%choice%'=='4' goto news
if '%choice%'=='5' goto updatecheck
if '%choice%'=='6' goto about
if '%choice%'=='7' goto end
echo Please enter 1 2 3 4 5 6 or 7.
pause
goto menu

:delupdate
del dpupdate.bat
goto menu

:mapmenu
cls
set map=
set /p map=Please enter map name (including .bsp)...  
if %map%==*.* goto invalidmap
echo :download1 >dlmap.bat
echo download ftp://85.214.56.218/pub/Maps/%map% /display:progress >>dlmap.bat
echo if not exist %map% goto download2 >>dlmap.bat
echo copy %map% %dppath%\pball\maps\%map% >>dlmap.bat
echo goto deletemap >>dlmap.bat
echo :download2 >>dlmap.bat
echo download http://www.dplogin.com/files/maps/%map% /display:progress >>dlmap.bat
echo if not exist %map% echo Download Failed. >>dlmap.bat
echo copy %map% %dppath%\pball\maps\%map% >>dlmap.bat
echo :deletemap >>dlmap.bat
echo del %map% >>dlmap.bat
call dlmap.bat
del dlmap.bat
pause
goto menu

:invalidmap
echo You cannot use that wildcard. For all maps please type *.bsp
pause
goto menu

:browsefiles
cls
download http://www.viciouz.co.uk/database/index.txt /display:silent
echo List of files displayed below:
echo.
type index.txt | more
echo.
goto filechoose

:searchfiles
cls
download http://www.viciouz.co.uk/database/index.txt /display:silent
set find=
set /p find=Enter Search Term (Capitalise 1st letter)...  
find "%find%" index.txt
goto filechoose

:filechoose
echo Type file number to download it. To go to the main menu, press enter.
set file=
set /p file=
if '%file%'=='' goto delmenu
if '%file%'=='info' goto fileinfo
echo download http://www.viciouz.co.uk/database/%file%.txt /display:silent >dlfileinfo.bat
call dlfileinfo.bat
del dlfileinfo.bat
set fileurl=
set /p fileurl= <%file%.txt
echo download %fileurl% /display:progress >dlfile.bat
call dlfile.bat
del dlfile.bat
del index.txt
echo File Downloaded.
pause
goto menu

:updatecheck
cls
echo Checking for updates...
download http://www.viciouz.co.uk/database/dpget.txt /display:silent
set version=05
set update=
set /p update= <dpget.txt
if not %version%==%update% goto update
echo No updates found.
pause
goto menu

:update
set updatechoice=
set /p updatechoice= Updates found. Install? (Y/N) 
if '%updatechoice%'=='n' goto menu
download http://www.viciouz.co.uk/dpget/dpget.zip /display:progress
download http://www.viciouz.co.uk/dpget/dpget-update.bat /display:progress
download http://www.viciouz.co.uk/dpget/unzip.exe /display:progress
dpget-update.bat

:news
cls
echo Checking news...
download http://www.viciouz.co.uk/database/news.txt /display:silent
type news.txt | more
del news.txt
echo.
echo Press any key to return to main menu...
pause >nul
goto menu

:about
cls
echo About DPGET v0.4
echo DPGET is a tool to download files relating to Digital Paintball 2.
echo Currently it includes a map-download feature, which attempts to download a map from www.dplogin.com
echo It also includes a simple file database hosted at viciouz.co.uk
echo DPGET written by ViciouZ (c) ViciouZ.co.uk 2007
echo DPGET uses File Downloader by Noel Danjou, which must not be redistributed outside of this package without prior consent.
echo Thanks to KnacK, Zorchenhimer and y00tz for their help and show of support.
pause
goto menu

:delmenu
del index.txt
goto menu

:end
cls
echo Thanks for using DPGet.
pause
exit